git-rebase: document suppression of duplicate commits
[git/dscho.git] / git-instaweb.sh
blob2e4eeccaceb434696071be9a8a2f6af24000d976
1 #!/bin/sh
3 # Copyright (c) 2006 Eric Wong
5 USAGE='[--start] [--stop] [--restart]
6 [--local] [--httpd=<httpd>] [--port=<port>] [--browser=<browser>]
7 [--module-path=<path> (for Apache2 only)]'
9 . git-sh-setup
11 fqgitdir="$GIT_DIR"
12 local="`git config --bool --get instaweb.local`"
13 httpd="`git config --get instaweb.httpd`"
14 browser="`git config --get instaweb.browser`"
15 port=`git config --get instaweb.port`
16 module_path="`git config --get instaweb.modulepath`"
18 conf=$GIT_DIR/gitweb/httpd.conf
20 # Defaults:
22 # if installed, it doesn't need further configuration (module_path)
23 test -z "$httpd" && httpd='lighttpd -f'
25 # probably the most popular browser among gitweb users
26 test -z "$browser" && browser='firefox'
28 # any untaken local port will do...
29 test -z "$port" && port=1234
31 start_httpd () {
32 httpd_only="`echo $httpd | cut -f1 -d' '`"
33 if test "`expr index $httpd_only /`" -eq '1' || \
34 which $httpd_only >/dev/null
35 then
36 $httpd $fqgitdir/gitweb/httpd.conf
37 else
38 # many httpds are installed in /usr/sbin or /usr/local/sbin
39 # these days and those are not in most users $PATHs
40 # in addition, we may have generated a server script
41 # in $fqgitdir/gitweb.
42 for i in /usr/local/sbin /usr/sbin "$fqgitdir/gitweb"
44 if test -x "$i/$httpd_only"
45 then
46 # don't quote $httpd, there can be
47 # arguments to it (-f)
48 $i/$httpd "$fqgitdir/gitweb/httpd.conf"
49 return
51 done
52 echo "$httpd_only not found. Install $httpd_only or use" \
53 "--httpd to specify another http daemon."
54 exit 1
56 if test $? != 0; then
57 echo "Could not execute http daemon $httpd."
58 exit 1
62 stop_httpd () {
63 test -f "$fqgitdir/pid" && kill `cat "$fqgitdir/pid"`
66 while test $# != 0
68 case "$1" in
69 --stop|stop)
70 stop_httpd
71 exit 0
73 --start|start)
74 start_httpd
75 exit 0
77 --restart|restart)
78 stop_httpd
79 start_httpd
80 exit 0
82 --local|-l)
83 local=true
85 -d|--httpd|--httpd=*)
86 case "$#,$1" in
87 *,*=*)
88 httpd=`expr "$1" : '-[^=]*=\(.*\)'` ;;
89 1,*)
90 usage ;;
92 httpd="$2"
93 shift ;;
94 esac
96 -b|--browser|--browser=*)
97 case "$#,$1" in
98 *,*=*)
99 browser=`expr "$1" : '-[^=]*=\(.*\)'` ;;
100 1,*)
101 usage ;;
103 browser="$2"
104 shift ;;
105 esac
107 -p|--port|--port=*)
108 case "$#,$1" in
109 *,*=*)
110 port=`expr "$1" : '-[^=]*=\(.*\)'` ;;
111 1,*)
112 usage ;;
114 port="$2"
115 shift ;;
116 esac
118 -m|--module-path=*|--module-path)
119 case "$#,$1" in
120 *,*=*)
121 module_path=`expr "$1" : '-[^=]*=\(.*\)'` ;;
122 1,*)
123 usage ;;
125 module_path="$2"
126 shift ;;
127 esac
130 usage
132 esac
133 shift
134 done
136 mkdir -p "$GIT_DIR/gitweb/tmp"
137 GIT_EXEC_PATH="`git --exec-path`"
138 GIT_DIR="$fqgitdir"
139 export GIT_EXEC_PATH GIT_DIR
142 webrick_conf () {
143 # generate a standalone server script in $fqgitdir/gitweb.
144 cat >"$fqgitdir/gitweb/$httpd.rb" <<EOF
145 require 'webrick'
146 require 'yaml'
147 options = YAML::load_file(ARGV[0])
148 options[:StartCallback] = proc do
149 File.open(options[:PidFile],"w") do |f|
150 f.puts Process.pid
153 options[:ServerType] = WEBrick::Daemon
154 server = WEBrick::HTTPServer.new(options)
155 ['INT', 'TERM'].each do |signal|
156 trap(signal) {server.shutdown}
158 server.start
160 # generate a shell script to invoke the above ruby script,
161 # which assumes _ruby_ is in the user's $PATH. that's _one_
162 # portable way to run ruby, which could be installed anywhere,
163 # really.
164 cat >"$fqgitdir/gitweb/$httpd" <<EOF
165 #!/bin/sh
166 exec ruby "$fqgitdir/gitweb/$httpd.rb" \$*
168 chmod +x "$fqgitdir/gitweb/$httpd"
170 cat >"$conf" <<EOF
171 :Port: $port
172 :DocumentRoot: "$fqgitdir/gitweb"
173 :DirectoryIndex: ["gitweb.cgi"]
174 :PidFile: "$fqgitdir/pid"
176 test "$local" = true && echo ':BindAddress: "127.0.0.1"' >> "$conf"
179 lighttpd_conf () {
180 cat > "$conf" <<EOF
181 server.document-root = "$fqgitdir/gitweb"
182 server.port = $port
183 server.modules = ( "mod_cgi" )
184 server.indexfiles = ( "gitweb.cgi" )
185 server.pid-file = "$fqgitdir/pid"
186 cgi.assign = ( ".cgi" => "" )
187 mimetype.assign = ( ".css" => "text/css" )
189 test "$local" = true && echo 'server.bind = "127.0.0.1"' >> "$conf"
192 apache2_conf () {
193 test -z "$module_path" && module_path=/usr/lib/apache2/modules
194 mkdir -p "$GIT_DIR/gitweb/logs"
195 bind=
196 test "$local" = true && bind='127.0.0.1:'
197 echo 'text/css css' > $fqgitdir/mime.types
198 cat > "$conf" <<EOF
199 ServerName "git-instaweb"
200 ServerRoot "$fqgitdir/gitweb"
201 DocumentRoot "$fqgitdir/gitweb"
202 PidFile "$fqgitdir/pid"
203 Listen $bind$port
206 for mod in mime dir; do
207 if test -e $module_path/mod_${mod}.so; then
208 echo "LoadModule ${mod}_module " \
209 "$module_path/mod_${mod}.so" >> "$conf"
211 done
212 cat >> "$conf" <<EOF
213 TypesConfig $fqgitdir/mime.types
214 DirectoryIndex gitweb.cgi
217 # check to see if Dennis Stosberg's mod_perl compatibility patch
218 # (<20060621130708.Gcbc6e5c@leonov.stosberg.net>) has been applied
219 if test -f "$module_path/mod_perl.so" && grep '^our $gitbin' \
220 "$GIT_DIR/gitweb/gitweb.cgi" >/dev/null
221 then
222 # favor mod_perl if available
223 cat >> "$conf" <<EOF
224 LoadModule perl_module $module_path/mod_perl.so
225 PerlPassEnv GIT_DIR
226 PerlPassEnv GIT_EXEC_DIR
227 <Location /gitweb.cgi>
228 SetHandler perl-script
229 PerlResponseHandler ModPerl::Registry
230 PerlOptions +ParseHeaders
231 Options +ExecCGI
232 </Location>
234 else
235 # plain-old CGI
236 list_mods=`echo "$httpd" | sed "s/-f$/-l/"`
237 $list_mods | grep 'mod_cgi\.c' >/dev/null 2>&1 || \
238 echo "LoadModule cgi_module $module_path/mod_cgi.so" >> "$conf"
239 cat >> "$conf" <<EOF
240 AddHandler cgi-script .cgi
241 <Location /gitweb.cgi>
242 Options +ExecCGI
243 </Location>
248 script='
249 s#^\(my\|our\) $projectroot =.*#\1 $projectroot = "'`dirname $fqgitdir`'";#
250 s#\(my\|our\) $gitbin =.*#\1 $gitbin = "'$GIT_EXEC_PATH'";#
251 s#\(my\|our\) $projects_list =.*#\1 $projects_list = $projectroot;#
252 s#\(my\|our\) $git_temp =.*#\1 $git_temp = "'$fqgitdir/gitweb/tmp'";#'
254 gitweb_cgi () {
255 cat > "$1.tmp" <<\EOFGITWEB
256 @@GITWEB_CGI@@
257 EOFGITWEB
258 sed "$script" "$1.tmp" > "$1"
259 chmod +x "$1"
260 rm -f "$1.tmp"
263 gitweb_css () {
264 cat > "$1" <<\EOFGITWEB
265 @@GITWEB_CSS@@
266 EOFGITWEB
269 gitweb_cgi $GIT_DIR/gitweb/gitweb.cgi
270 gitweb_css $GIT_DIR/gitweb/gitweb.css
272 case "$httpd" in
273 *lighttpd*)
274 lighttpd_conf
276 *apache2*)
277 apache2_conf
279 webrick)
280 webrick_conf
283 echo "Unknown httpd specified: $httpd"
284 exit 1
286 esac
288 start_httpd
289 test -z "$browser" && browser=echo
290 url=http://127.0.0.1:$port
291 $browser $url || echo $url